unit CalcPad;
{$ifdef FPC}{$mode objfpc}{$h+}{$INTERFACES CORBA}{$endif}
{$LONGSTRINGS OFF}


interface

uses
 Classes, SysUtils, Math, msegui,mclasses,mseclasses,mseforms,mseevent,
 msegraphics,msekeyboard,msegraphutils,{msemenus,}mseguiglob,mseact,
 msesimplewidgets,msewidgets,msedispwidgets,msestrings,msetypes,mseDialog,
 CalcFuncs;

type
 tKeyPadfo = class (tDialogform)
   Eingabefeld:  tgroupbox;
   Eingabe:      tstringdisp;
   tbutton1:     tbutton;
   tbutton2:     tbutton;
   tbutton3:     tbutton;
   tbutton4:     tbutton;
   tbutton5:     tbutton;
   tbutton6:     tbutton;
   tbutton7:     tbutton;
   tbutton8:     tbutton;
   tbutton9:     tbutton;
   tbutton0:     tbutton;
   ClearKey:     tbutton;
   EnterKey:     tbutton;
   DecimalKey:   tbutton;
   Abbruch:      tstockglyphbutton;
   DelKey:       tstockglyphbutton;
   Operatorfeld: tgroupbox;
   SignKey:      tbutton;
   DivideKey:    tbutton;
   MultiplyKey:  tbutton;
   SubtractKey:  tbutton;
   AddKey:       tbutton;
   EqualKey:     tbutton;

   procedure KeyDown  (const sender: twidget; var ainfo: keyeventinfoty);

   procedure PadClose (const sender: TObject); VIRTUAL;
   procedure NewPad   (const sender: TObject); VIRTUAL; // ABSTRACT;
   procedure PadKey   (const sender: TObject); VIRTUAL; ABSTRACT;
   procedure Clear    (const sender: TObject); VIRTUAL; ABSTRACT;
   procedure Delete   (const sender: TObject); VIRTUAL; ABSTRACT;
   procedure PointKey (const sender: TObject); VIRTUAL; ABSTRACT;
   procedure Operate  (const sender: TObject); VIRTUAL;
   procedure ChSign   (const sender: TObject); VIRTUAL;
////////////////////////////////////////////
   class function hasresource: boolean; override;
////////////////////////////////////////////

 Private
   PWChar: char;
   currOp: Operation;

   procedure SetPWchar (NewPWchar: char);      VIRTUAL; ABSTRACT;
   procedure setCalc   (hasOps: boolean);      VIRTUAL;
   FUNCTION  getCalc:  boolean;                VIRTUAL;
   procedure SetEntry  (const InText: string); VIRTUAL;

 Public
   resizefromcenter: boolean;

 Published
   PROPERTY PasswordChar: char READ PWChar WRITE PWChar;
 end;

///////////////////////////////////////////////////////

 tIntKeyPadfo = class (tKeyPadfo)
   procedure NewPad   (const sender: TObject); OVERRIDE;
   procedure PadKey   (const sender: TObject); OVERRIDE;
   procedure Clear    (const sender: TObject); OVERRIDE;
   procedure Delete   (const sender: TObject); OVERRIDE;

 Private
   currValue: integer;

   procedure SetValue (NewValue: integer); VIRTUAL;

 Public
   function GetText: string; VIRTUAL;

 Published
   PROPERTY Value: integer READ currValue WRITE SetValue;
 end;

//////////////////////////

 tFloatKeyPadfo = class (tKeyPadfo)
   procedure NewPad   (const sender: TObject); OVERRIDE;
   procedure PadKey   (const sender: TObject); OVERRIDE;
   procedure Clear    (const sender: TObject); OVERRIDE;
   procedure Delete   (const sender: TObject); OVERRIDE;
   procedure PointKey (const sender: TObject); OVERRIDE;

 Private
   currValue: realty;
   pointpos:  smallint;

   procedure SetValue (NewValue: realty); VIRTUAL;

 Public
   function GetText: string; VIRTUAL;

 Published
   PROPERTY Value: realty READ currValue WRITE SetValue;
 end;

///////////////////////////////////////////////////////

 tIntCalcPadfo = class (tIntKeyPadfo)
   procedure NewPad   (const sender: TObject); OVERRIDE;
   procedure PadKey   (const sender: TObject); OVERRIDE;
   procedure Clear    (const sender: TObject); OVERRIDE;
   procedure Delete   (const sender: TObject); OVERRIDE;
   procedure Operate  (const sender: TObject); OVERRIDE;
   procedure ChSign   (const sender: TObject); OVERRIDE;

 Private
   Calculation: IntCalculator;

   procedure SetPWchar (NewPWchar: char);   OVERRIDE;
   FUNCTION  getValue: integer;             VIRTUAL;

 Published
   PROPERTY PasswordChar: char    READ PWChar   WRITE SetPWChar;
   PROPERTY Value:        integer READ getValue WRITE setValue;
   PROPERTY canCalulate:  boolean READ getCalc  WRITE setCalc;
 end;

//////////////////////////

 tFloatCalcPadfo = class (tFloatKeyPadfo)
   procedure NewPad   (const sender: TObject); OVERRIDE;
   procedure PadKey   (const sender: TObject); OVERRIDE;
   procedure Clear    (const sender: TObject); OVERRIDE;
   procedure Delete   (const sender: TObject); OVERRIDE;
   procedure PointKey (const sender: TObject); OVERRIDE;
   procedure Operate  (const sender: TObject); OVERRIDE;
   procedure ChSign   (const sender: TObject); OVERRIDE;

 Private
   Calculation: FloatCalculator;

   procedure SetPWchar (NewPWchar: char);  OVERRIDE;
   FUNCTION  getValue: realty;             VIRTUAL;

 Published
   PROPERTY PasswordChar: char    READ PWChar   WRITE SetPWChar;
   PROPERTY Value:        realty  READ getValue WRITE setValue;
   PROPERTY canCalulate:  boolean READ getCalc  WRITE setCalc;
 end;

///////////////////////////////////////////////////////

implementation

uses
 CalcPad_mfm;

///////////////////////////////////////////////////////
class function tKeyPadfo.hasresource: boolean;
 begin
   result:= false;
 end;
////////////////////////////////////////////

procedure tKeyPadfo.NewPad (const sender: TObject);
 begin
   currOp:= _done;
 end;

procedure tKeyPadfo.SetEntry (const InText: string);
 begin
   WITH Eingabe DO BEGIN
     IF PasswordChar = #0
       THEN Value:= InText
       ELSE Value:= StringOfChar (PasswordChar, Length (InText));
   END (* WITH Eingabe *);
 end;

procedure tKeyPadfo.setCalc (hasOps: boolean);
 begin
   IF hasOps THEN BEGIN
     Self.Bounds_CX:= Eingabefeld.Bounds_CX+ Operatorfeld.Bounds_CX;
     IF resizefromcenter THEN Self.Bounds_X:= Self.Bounds_X- (Operatorfeld.Bounds_CX DIV 2);
     DivideKey.Caption:= char (Key_Division);
   END (* IF Value *)
   ELSE BEGIN
     Self.Bounds_CX:= Eingabefeld.Bounds_CX;
     IF resizefromcenter THEN Self.Bounds_X:= Self.Bounds_X+ (Operatorfeld.Bounds_CX DIV 2);
   END (* ELSE *);
   Operatorfeld.visible:= hasOps;
 end;

FUNCTION tKeyPadfo.getCalc: boolean;
 begin
   getCalc:= Operatorfeld.visible;
 end;

PROCEDURE tKeyPadfo.Operate (const sender: TObject);
 BEGIN
   currOp:= Operation (tbutton (Sender).Tag);
 END;

procedure tKeyPadfo.ChSign (const sender: TObject);
 begin
 end;

procedure tKeyPadfo.PadClose (const sender: TObject);
 begin
   IF currOp = _done
     THEN // Window.ModalResult:= mr_ok;
 end;

procedure tKeypadfo.KeyDown (const sender: twidget; var ainfo: keyeventinfoty);
 begin
   IF aInfo.Key = keyty (DefaultFormatSettings.DecimalSeparator) THEN DecimalKey.Execute
   ELSE IF aInfo.Key = Key_Return THEN BEGIN
     // Tricky: neccessary to avoid false setfocus call
     // - setting ow_keyreturntaborder is neccessary to allow Enter key at all...
     WITH Abbruch DO OptionsWidget:= OptionsWidget- [ow_keyreturntaborder];
     EnterKey.Execute;
   END (* IF aInfo.Key = Key_Return *);
 end;

///////////////////////////////////////////////////////

procedure tIntKeyPadfo.NewPad (const sender: TObject);
 begin
   WITH DecimalKey DO BEGIN
     State:= State+ [as_invisible];
   END (* WITH DecimalKey *);
//   EnterKey.Bounds_CY:= DecimalKey.Bounds_Y+ DecimalKey.Bounds_CY- EnterKey.Bounds_Y;
   EnterKey.Bounds_CY:= 93;
   setCalc (Self IS tIntCalcPadfo);
   Inherited; Clear (Self);
 end;

procedure tIntKeyPadfo.SetValue (NewValue: integer);
 begin
   currValue:= NewValue;
   SetEntry (IntToStr (currValue));
 end;

function tIntKeyPadfo.GetText: string;
 begin
   GetText:= IntToStr (currValue);
 end;

procedure tIntKeyPadfo.PadKey (const sender: TObject);
 begin
   Value:= 10* Value+ tbutton (Sender).Tag;
 end;

procedure tIntKeyPadfo.Clear (const sender: TObject);
 begin
   Value:= 0;
 end;

procedure tIntKeyPadfo.Delete (const sender: TObject);
 begin
   Value:= Value DIV 10;
 end;

//////////////////////////

procedure tFloatKeyPadfo.NewPad (const sender: TObject);
 begin
   WITH DecimalKey DO BEGIN
     Caption:= DefaultFormatSettings.DecimalSeparator;
     State:= State- [as_invisible];
     OnExecute:= @PointKey;
   END (* WITH DecimalKey *);

   EnterKey.Bounds_CY:= 61;
   setCalc (Self IS tFloatCalcPadfo);
   Inherited; Clear (Self);
 end;

procedure tFloatKeyPadfo.SetValue (NewValue: realty);
 begin
   currValue:= NewValue;
   IF pointpos > 0
     THEN SetEntry (FloatToStrF (currValue, ffFixed, 0, pointpos))
     ELSE
       IF pointpos < 0
         THEN SetEntry (FloatToStrF (currValue, ffFixed, 0, 0))
         ELSE SetEntry (FloatToStrF (currValue, ffFixed, 0, 0)+ DefaultFormatSettings.DecimalSeparator);
 end;

function tFloatKeyPadfo.GetText: string;
 begin
   IF pointpos > 0
     THEN GetText:= FloatToStrF (currValue, ffFixed, 0, pointpos)
     ELSE GetText:= FloatToStrF (currValue, ffFixed, 0, 0);
 end;

procedure tFloatKeyPadfo.PointKey (const sender: TObject);
 begin
   IF pointpos < 0 THEN BEGIN
     pointpos:= 0; SetValue (currValue);
   END;
 end;

procedure tFloatKeyPadfo.PadKey (const sender: TObject);
 begin
   IF pointpos >= 0 THEN BEGIN
     Inc (pointpos);
     Value:= RoundTo (Value+ (tbutton (Sender).Tag* 10.0**-pointpos), -pointpos);
   END (* IF decimals < 1.0 *)
   ELSE IF pointpos < 0 THEN Value:= (10.0* Value)+ tbutton (Sender).Tag;
 end;

procedure tFloatKeyPadfo.Clear (const sender: TObject);
 begin
   pointpos:= -1; Value:= 0.0;
 end;

procedure tFloatKeyPadfo.Delete (const sender: TObject);
 begin
   IF pointpos > 0 THEN Dec (pointpos);

   IF pointpos > 0
     THEN Value:= RoundTo (Value, -pointpos)
     ELSE IF pointpos = 0 THEN pointpos:= -1
       ELSE Value:= Int (Value* 0.1);
    end;

///////////////////////////////////////////////////////

procedure tIntCalcPadfo.NewPad (const sender: TObject);
 begin
   Calculation:= IntCalculator.Create;
   Inherited;
 end;

procedure tIntCalcPadfo.SetPWchar (NewPWchar: char);
 begin
   PWchar:= NewPWchar;
   setCalc (PWchar = #0);
 end;

FUNCTION tIntCalcPadfo.getValue: integer;
 BEGIN
   getValue:= Calculation.Value;
 END;

procedure tIntCalcPadfo.PadKey (const sender: TObject);
 begin
   Calculation.nextDigit (tbutton (Sender).Tag);
   Value:= Calculation.Value;
 end;

procedure tIntCalcPadfo.Clear (const sender: TObject);
 begin
   Calculation.Clear;
   Value:= Calculation.Value;
 end;

procedure tIntCalcPadfo.Delete (const sender: TObject);
 begin
   Calculation.Delete;
   Value:= Calculation.Value;
 end;

procedure tIntCalcPadfo.Operate (const sender: TObject);
 BEGIN
   Calculation.Operate (Operation (tbutton (Sender).Tag));
   Value:= Calculation.Value;
   Inherited;
 END (* Operate *);

procedure tIntCalcPadfo.ChSign (const sender: TObject);
 begin
   Calculation.ChangeSign;
   Value:= Calculation.Value;
 end;

//////////////////////////

procedure tFloatCalcPadfo.NewPad (const sender: TObject);
 begin
   Calculation:= FloatCalculator.Create;
   Inherited;
 end;

procedure tFloatCalcPadfo.SetPWchar (NewPWchar: char);
 begin
   PWchar:= NewPWchar;
   setCalc (PWchar = #0);
 end;

FUNCTION tFloatCalcPadfo.getValue: realty;
 BEGIN
   getValue:= Calculation.Value;
 END;

procedure tFloatCalcPadfo.PointKey (const sender: TObject);
 begin
   Calculation.setPoint;
   pointpos:= Calculation.Places; Value:= Calculation.Value;
 end;

procedure tFloatCalcPadfo.PadKey (const sender: TObject);
 begin
   Calculation.nextDigit (tbutton (Sender).Tag);
   pointpos:= Calculation.Places; Value:= Calculation.Value;
 end;

procedure tFloatCalcPadfo.Clear (const sender: TObject);
 begin
   Calculation.Clear;
   pointpos:= Calculation.Places; Value:= Calculation.Value;
 end;

procedure tFloatCalcPadfo.Delete (const sender: TObject);
 begin
   Calculation.Delete;
   pointpos:= Calculation.Places; Value:= Calculation.Value;
 end;

procedure tFloatCalcPadfo.Operate (const sender: TObject);
 BEGIN
   Calculation.Operate (Operation (tbutton (Sender).Tag));
   pointpos:= Calculation.Places; // Value:= Calculation.Value;
   IF pointpos = 0 THEN pointpos:= -1;
   Value:= Calculation.Value;
   Inherited;
 END (* Operate *);

procedure tFloatCalcPadfo.ChSign (const sender: TObject);
 begin
   Calculation.ChangeSign;
   Value:= Calculation.Value;
 end;

end.
