unit SQLForm;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
{$WARN IMPLICIT_STRING_CAST OFF}

interface

uses
 sysutils, strutils, cLocale, mseclasses, msetypes, mseglob, mseguiglob,
 msestockobjects, mseapplication, msestrings, msestat, msestatfile, msemenus,
 msegui, msegraphutils, mseforms, msedialog, msewidgets,msememodialog, mseedit,
 msesimplewidgets, msesplitter, msemenuwidgets, msegrids, msegridsglob, mseact,
 FieldTypeError, msedatabase, msepqconnection, msqldb, mdb, msedb, msedataedits,
 msedbedit, mselookupbuffer, msebufdataset, msesqldb, msesqlresult, msedatalist,
 msedispwidgets, msefontdialog, msepopupcalendar, msecalendardatetimeedit,
 CalcPad;  //, postgres3dyn;

type
  StatfileKeeper = ARRAY OF tStatFile;

 tSQLFormfo = class (tmseform)
   Mainfield:      texpandingwidget;
   MenuBar:        tmainmenuwidget;
   MenuPopup:      tpopupmenu;
   Navigator:      tdbnavigator;
   Fieldlist:      tdropdownlistedit;
   DBDaten:        tdbstringgrid;
   RowCount:       tintegerdisp;
   currentRow:     tintegerdisp;
   Dbasename:      tstringdisp;
   Tablename:      tstringdisp;
   PostConnection: tmsepqconnection;
   Transaction:    tmsesqltransaction;
   DataSource:     tmsedatasource;
   SQLquery:       tmsesqlquery;
   SQLresult:      tsqlresult;
   PStateFile:     tstatfile;

   OrderForm:      tmseformwidget;
   OrderEdit:      tstringedit;
   OrderActive:    tstockglyphbutton;
   OderCancel:     tstockglyphbutton;
   OrderApply:     tstockglyphbutton;
   OrderClear:     tstockglyphbutton;
   Ascender:       tstockglyphbutton;
   Descender:      tstockglyphbutton;
   Advancer:       tstockglyphbutton;
   OrderCol:       tstockglyphbutton;

   FilterForm:     tmseformwidget;
   FilterEdit:     tstringedit;
   FilterActive:   tstockglyphbutton;
   FilterCancel:   tstockglyphbutton;
   FilterApply:    tstockglyphbutton;
   FilterClear:    tstockglyphbutton;
   FilterCol:      tstockglyphbutton;
   FilterOperator: tdropdownlistedit;

   UserDataForm:   tmseformwidget;
   doLogin:        tstockglyphbutton;
   HostName:       tedit;
   UserName:       tedit;
   Password:       tedit;

   PROCEDURE FindDatabases (CONST Sender: TObject);
   PROCEDURE FindTables    (CONST Sender: TObject);
   PROCEDURE SelectTable   (CONST Sender: TObject);
   procedure InitAccess    (const sender: TObject);

   procedure ShowOrder     (const sender: TObject);
   procedure ActiveOrder   (const sender: TObject);
   procedure ClearOrder    (const sender: TObject);
   procedure OrderTable    (const sender: TObject);
   procedure setAscend     (const sender: TObject);
   procedure setDescend    (const sender: TObject);
   procedure setAdvance    (const sender: TObject);
   procedure ColOrder      (const sender: TObject);

   procedure ShowFilter    (const sender: TObject);
   procedure ActiveFilter  (const sender: TObject);
   procedure ClearFilter   (const sender: TObject);
   procedure FilterTable   (const sender: TObject);
   procedure ColFilter     (const sender: TObject);
   procedure setOperator   (const sender: TObject; var avalue: msestring;
                            var accept: Boolean);
   procedure selectField   (const sender: TObject; var avalue: msestring;
                            var accept: Boolean);
   // Communication between main and popup menus
   procedure getAutoopen   (const sender: TObject);
   procedure setAutoopen   (const sender: TObject);

   procedure SetFont       (const sender: TObject);
   procedure Calculate     (const sender: TObject);
   procedure ShowDate      (const sender: TObject);
   procedure EditMemo      (const sender: TObject);
   procedure getLogin      (const sender: TObject);
   procedure TryLogin      (const sender: TObject);

   procedure RausHier       (const sender: TObject);
   procedure Aufmachen      (const sender: TObject);
   procedure Abhaengen      (const sender: TObject);
   procedure CellEvent      (const sender: TObject; var info: celleventinfoty);
   procedure SetFilename    (const sender: TObject);
   procedure AssessStates   (const sender: TObject; const filer: tstatfiler);
   procedure ReadStates     (const sender: TObject; const reader: tstatreader);
   procedure ReadTablefcts  (const sender: TObject; const reader: tstatreader);
   procedure WriteStates    (const sender: TObject; const writer: tstatwriter);
   procedure WriteTablefcts (const sender: TObject; const writer: tstatwriter);
   procedure StateRead      (const sender: TObject);
   procedure ErrorOnPost    (DataSet: TDataSet; E: EDatabaseError;
                             var DataAction: TDataAction);
   procedure ErrorOnUpdate  (const sender: tmsebufdataset; var e: EDatabaseError;
                             const updatekind: TUpdateKind;
                             var response: resolverresponsesty);
  PRIVATE
   { Private declarations }
   useOrder,
   OrderOn,
   useFilter,
   FilterOn: boolean;
   currCol:  string;
   LastDate: tdatetime;
   MemoText: mseStringArTy;
   TableFunctions: StatfileKeeper;

   procedure ShowView      (const sender: TObject);
   procedure HideView      (const sender: TObject);
   PROCEDURE changeFont    (CONST FontBeingSet: tWidgetFont);
   procedure Fieldsize     (const FieldDef: TFieldDef; out Length, Decs: integer);
   FUNCTION findFcts       ({const} newTable: string):  tstatfile;   // CONST parameters cannot passed on further!?
   procedure NewTablefcts  (const newTable: string);
   procedure saveTableFcts (const newTable: string);
 end;

var
 SQLFormfo: tSQLFormfo;


implementation
  
uses
 SQLForm_mfm;

CONST
  DBquery =     'select datname from pg_database order by datname;';
  TableQuery =  'select tablename from pg_tables where schemaname = ''public'''+
                ' order by tablename;';
  SelectQuery = 'select * from "';
  OrderBegin =  ' order by ';
  FilterBegin = ' where ';
  SelectEnd =   '"';
  SQLend =      ';';
  PgPass =      '/.pgpass';
  DBSign =      'PSQL_';

  ColOptions:  coloptionsty =  [co_savevalue,co_savestate,co_mouseselect,co_mousescrollrow];
  ColOptions1: coloptions1ty = [co1_rowfont,co1_rowcolor,co1_zebracolor,co1_rowcoloractive,co1_rowcolorfocused,co1_rowreadonly,co1_autocolwidth,co1_autoheaderwidth];

{$Macro On}
// defined as macros here for easier adaptation to layout changes
{$define FileMenuOpen:=    MenuBar.Menu.Menu [0][0]}
{$define FileMenuClose:=   MenuBar.Menu.Menu [0][1]}
{$define DatabaseMenu:=    MenuBar.Menu.Menu [1]}
{$define TableMenu:=       MenuBar.Menu.Menu [2]}
{$define ViewMenuOrder:=   MenuBar.Menu.Menu [3][0]}
{$define ViewMenuFilter:=  MenuBar.Menu.Menu [3][1]}
{$define OptionMenuAuto:=  MenuBar.Menu.Menu [4][0]}
{$define OptionMenuFont:=  MenuBar.Menu.Menu [4][1]}
{$define OptionMenuPass:=  MenuBar.Menu.Menu [4][2]}

{$define PopupMenuOrder:=  MenuPopup.Menu  [1]}
{$define PopupMenuFilter:= MenuPopup.Menu  [2]}
{$define PopupMenuAuto:=   MenuPopup.Menu  [9]}
{$define PopupMenuFont:=   MenuPopup.Menu [10]}
{$define PopupMenuPass:=   MenuPopup.Menu [11]}


PROCEDURE getPgAccess (VAR HostName, Username, Password: string);
 VAR
   done:   boolean = false;
   PgName,
   PgLine: string;
   PgUser: TextFile;
 BEGIN
   PgName:= // used for pg user password file path
{$ifdef Windows}
              msestring (toSysfilePath (sys_getuserhomedir))+
{$else}
              GetEnvironmentVariable ('HOME')+
{$endif}
              PgPass;

   IF FileExists (PgName) THEN BEGIN
     Assign{File} (PgUser, PgName); Reset (PgUser);
     WHILE NOT (done OR EoF (PgUser)) DO BEGIN
       ReadLn (PgUser, PgLine);         // used for parsing
       IF (PgLine [1] <> '#') AND       // NOT a comment line
          (Pos (':*:', PgLine) <> 0)    // general access
       THEN BEGIN
         HostName:= ExtractWord (1, PgLine, [':']);
         Username:= ExtractWord (4, PgLine, [':']);
         Password:= ExtractWord (5, PgLine, [':']);
         done:= true;
       END;
     END;
     Close{File} (PgUser);
   END;
   IF NOT done THEN BEGIN
     Username:= ''; Password:= '';
   END;
 END;

procedure tSQLFormfo.RausHier (const sender: TObject);
 begin
   IF PostConnection.Connected THEN Abhaengen (Self);
   PostConnection.Connected:= false;
   Close;
   Application.Terminate;
 end;

procedure tSQLFormfo.Aufmachen (const sender: TObject);
 var
   Prec, Sz,
   i, n: integer;
   s: string;
//   t: tFieldType;
 begin
//   InitializePostgres3 (['/usr/lib64/postgresql/14/lib/libpq.so']);

   WITH PostConnection DO BEGIN
     DatabaseName:= Dbasename.Value;
     TRY
       Connected:= true;
     EXCEPT
       ON Exception DO
         Abhaengen (NIL);
     END;
     IF Connected THEN BEGIN
       s:= SelectQuery+ Tablename.Value+ SelectEnd;
        NewTablefcts (DBSign+ Dbasename.Value+ '_'+ Tablename.Value);

       IF useFilter AND FilterOn AND (FilterEdit.Value <> '')
         THEN s:= s+ FilterBegin+ FilterEdit.Value;

       IF useOrder AND OrderOn AND (OrderEdit.Value <> '')
         THEN s:= s+ OrderBegin+ OrderEdit.Value;

       DataSource.enabled:= true;
       WITH SQLquery DO BEGIN
         SQL.Count:= 1;
         SQL [0]:= s+ SQLend;
         Tablename:= Self.Tablename.Value;
         TRY
           active:= true;
         EXCEPT
           ON Exception DO BEGIN
             Abhaengen (NIL);
           END;
         END;
       END;

       IF SQLquery.active THEN BEGIN
         WITH DBDaten, DataSource.DataSet DO BEGIN
           n:= FieldDefs.Count;
           DataCols.Count:= n; FixRows [-1].Captions.Count:= n;
           DataCols.Options:= ColOptions; DataCols.Options1:= ColOptions1;
           FOR i:= 0 TO pred (n) DO BEGIN
             IF FieldDefs [i].DataType = ftUnknown THEN BEGIN
///               t:= FieldDefs [i].DataType;
///               FieldDefs[i].DataType:= ftVariant;  // ?????????????
             END ELSE IF FieldDefs [i].DataType = ftFloat THEN BEGIN
               DataCols [i].DataField:= FieldDefs [i].Name;
               s:= FieldDefs [i].Name;
               Prec:= FieldDefs [i].Precision;
               Sz:= FieldDefs [i].Size;
//               t:= FieldDefs [i].DataType;
             END ELSE IF FieldDefs [i].DataType = ftCurrency THEN BEGIN  ////////////// !!!!!!!!!!!!!
               DataCols [i].DataField:= FieldDefs [i].Name;
               s:= FieldDefs [i].Name;
               Prec:= 8; Sz:= 2;
               FieldDefs [i].Precision:= Prec;
               FieldDefs [i].Size:= Sz;
             END ELSE WITH DataCols [i] DO BEGIN
               DataField:= FieldDefs [i].Name;
             END;
             FixRows [-1].Captions [i].Caption:= FieldDefs [i].Name;
           END;
           FOR i:= 0 TO pred (n) DO
             WITH DataCols [i] DO Width:= Width+ 6;
         END;
         RowCount.Value:= SQLquery.RowsReturned;
         RowCount.show; currentRow.show; DBDaten.show;
  
         WITH DBDaten, Fieldlist, Dropdown DO BEGIN
           DropdownRowcount:= n;
           FOR i:= 0 TO pred (n) DO
             WITH DataSource.DataSet.FieldDefs [i] DO BEGIN
               Cols [0].insert (i, Name);
               Cols [1].insert (i, FieldTypeName [DataType]);
  
               Fieldsize (DataSource.DataSet.FieldDefs [i], Prec, Sz);
               IF Prec < 0
                 THEN Cols [2].insert (i, IntToStr (Sz))
                 ELSE Cols [2].insert (i, IntToStr (Prec)+ '.'+ IntToStr (Sz));
             END;
           show;
         END;
  
         WITH FileMenuClose DO
           state:= state- [as_disabled, as_localdisabled];
         WITH FileMenuOpen DO
           state:= state+ [as_disabled, as_localdisabled];
         WITH ViewMenuOrder DO
           state:= state- [as_disabled, as_localdisabled];
         WITH ViewMenuFilter DO
           state:= state- [as_disabled, as_localdisabled];
         WITH PopupMenuOrder DO
           state:= state- [as_disabled, as_localdisabled];
         WITH PopupMenuFilter DO
           state:= state- [as_disabled, as_localdisabled];
       END;
     END;
   END;
//   ReleasePostgres3;
 end;

procedure tSQLFormfo.Abhaengen (const sender: TObject);
 begin
   WITH SQLquery DO BEGIN
     saveTableFcts (DBSign+ Dbasename.Value+ '_'+ Self.Tablename.Value);
     active:= false; Tablename:= '';
     SQL.Clear; SQLUpdate.Clear;
     Fields.Clear;   // VERY important to allow re-opening of another database after modifications!
   END;
   DataSource.enabled:= false;
   WITH PostConnection DO BEGIN
     Connected:= false;
     IF NOT Connected THEN BEGIN
       DBDaten.hide;
       WITH DBDaten DO BEGIN
         DataCols.Clear; FixRows [-1].Captions.Clear;
       END;
       WITH Fieldlist DO BEGIN
         hide; Dropdown.Cols.Clear;
       END;
       RowCount.hide; currentRow.hide;
       currCol:= '';

       WITH FileMenuOpen DO
         state:= state- [as_disabled, as_localdisabled];
       WITH FileMenuClose DO
         state:= state+ [as_disabled, as_localdisabled];
       WITH ViewMenuOrder DO
         state:= state+ [as_disabled, as_localdisabled];
       WITH ViewMenuFilter DO
         state:= state+ [as_disabled, as_localdisabled];
       WITH PopupMenuOrder DO
         state:= state+ [as_disabled, as_localdisabled];
       WITH PopupMenuFilter DO
         state:= state+ [as_disabled, as_localdisabled];
     END;
   END;
 end;


PROCEDURE tSQLFormfo.FindDatabases (CONST Sender: TObject);
 VAR
   r, rr: integer;
 BEGIN
   WITH PostConnection DO BEGIN
     Connected:= true;
     IF Connected THEN BEGIN
       SQLresult.SQL.Count:= 1;
       SQLresult.SQL [0]:= DBquery;
       SQLresult.active:= true;
       rr:= SQLresult.RowsReturned;
       IF rr > 0 THEN BEGIN
         WITH DatabaseMenu DO BEGIN
           Submenu.Count:= rr;
         END;
         FOR r:= 0 TO pred (rr) DO
           WITH DatabaseMenu [r] DO BEGIN
             Caption:= SQLresult.asVariantArAr [r][0];
             Options:= Options+ [mao_radiobutton];
             onExecute:= @FindTables;
           END;
       END;
       Connected:= false;
     END;
   END;
   InitAccess (NIL);
 END;

PROCEDURE tSQLFormfo.FindTables (CONST Sender: TObject);
 VAR
   r, rr:  integer;
 BEGIN
   IF PostConnection.Connected THEN Abhaengen (Self);

   WITH PostConnection DO BEGIN
     DatabaseName:= (Sender AS tMenuItem).Caption;
     Dbasename.Value:= DatabaseName; Dbasename.show;
     Connected:= true;
     IF Connected THEN BEGIN
       SQLresult.SQL.Count:= 1;
       SQLresult.SQL [0]:= TableQuery;
       SQLresult.active:= true;
       rr:= SQLresult.RowsReturned;
       IF rr > 0 THEN BEGIN
         WITH TableMenu DO BEGIN
           state:= state- [as_disabled, as_localdisabled];
           Submenu.Count:= rr;
         END;
         FOR r:= 0 TO pred (rr) DO
           WITH TableMenu [r] DO BEGIN
             Caption:= SQLresult.asVariantArAr [r][0];
             Options:= Options+ [mao_radiobutton];
             onExecute:= @SelectTable;
           END;
       END;
       Connected:= false;
     END;
   END;
 END;

PROCEDURE tSQLFormfo.SelectTable (CONST Sender: TObject);
 BEGIN
   IF PostConnection.Connected THEN Abhaengen (Self)  //;
   ELSE
     IF OptionMenuAuto.checked AND (Tablename.Value = (Sender AS tMenuItem).Caption) THEN BEGIN
       useOrder:= false; useFilter:= false;
     END;

   IF Tablename.Value <> (Sender AS tMenuItem).Caption THEN BEGIN
     useOrder:= false; useFilter:= false;
   END;
   Tablename.Value:= (Sender AS tMenuItem).Caption;

   WITH FileMenuOpen DO
     state:= state- [as_disabled, as_localdisabled];

   Tablename.show;

   IF OptionMenuAuto.checked THEN Aufmachen (NIL);
 END;

procedure tSQLFormfo.CellEvent (const sender: TObject; var info: celleventinfoty);
 BEGIN
   WITH info DO
     IF NOT ((Cell.col < 0) OR (CellBefore.col < 0) OR (newCell.col < 0))
        AND (EventKind = cek_enter) AND (Cell.Col = newCell.Col)
     THEN BEGIN
       IF DBDaten.visible AND (DBDaten.FixRows [-1].Captions.Count > 0) THEN
         currCol:= DBDaten.FixRows [-1].Captions [Cell.Col].Caption;
     END;
   currentRow.Value:= SQLquery.RecNo;
 END;

procedure tSQLFormfo.InitAccess (const sender: TObject);
 VAR
   i: integer;
 BEGIN
   IF Dbasename.Value <> '' THEN BEGIN
     i:= 0;
     WHILE (i < DatabaseMenu.Submenu.Count) AND
           (DatabaseMenu [i].Caption <> Dbasename.Value) DO Inc (i);

     IF i < DatabaseMenu.Submenu.Count THEN BEGIN
       DatabaseMenu [i].checked:= true;
       Dbasename.show;
       FindTables (DatabaseMenu [i]);

       IF Tablename.Value <> '' THEN BEGIN
         i:= 0;
         WHILE (i < TableMenu.Submenu.Count) AND
               (TableMenu [i].Caption <> Tablename.Value) DO Inc (i);

         IF i < TableMenu.Submenu.Count THEN BEGIN
           TableMenu [i].checked:= true;
           Tablename.show;
           SelectTable (TableMenu [i]);
         END;
       END;
     END;
   END;
 END;


procedure tSQLFormfo.ShowView (const sender: TObject);
 BEGIN
   WITH ViewMenuOrder DO
     state:= state+ [as_invisible,as_localinvisible];
   WITH ViewMenuFilter DO
     state:= state+ [as_invisible,as_localinvisible];
   WITH PopupMenuOrder DO
     state:= state+ [as_invisible,as_localinvisible];
   WITH PopupMenuFilter DO
     state:= state+ [as_invisible,as_localinvisible];
 END;

procedure tSQLFormfo.HideView (const sender: TObject);
 BEGIN
   WITH ViewMenuOrder DO
     state:= state- [as_invisible,as_localinvisible];
   WITH ViewMenuFilter DO
     state:= state- [as_invisible,as_localinvisible];
   WITH PopupMenuOrder DO
     state:= state- [as_invisible,as_localinvisible];
   WITH PopupMenuFilter DO
     state:= state- [as_invisible,as_localinvisible];
 END;

procedure tSQLFormfo.ShowOrder (const sender: TObject);
 BEGIN
   ShowView (NIL);
   OrderForm.show;
   OrderEdit.setFocus;
 END;

procedure tSQLFormfo.ClearOrder (const sender: TObject);
 BEGIN
   OrderEdit.Value:= '';
 END;

procedure tSQLFormfo.ActiveOrder (const sender: TObject);
 BEGIN
   WITH OrderActive DO BEGIN
     IF Sender  <> NIL THEN OrderOn:= NOT OrderOn;
     IF OrderOn
       THEN glyph:= stg_list
       ELSE glyph:= stg_mmclear;
   END;
 END;

procedure tSQLFormfo.OrderTable (const sender: TObject);
 BEGIN
   HideView (NIL);
   useOrder:= Sender = TObject (OrderApply);
   OrderForm.hide;

   IF useorder THEN
     OrderEdit.Value:= TrimRightSet (OrderEdit.Value, [' ', ',']);

   TRY
     Abhaengen (NIL);
     IF OptionMenuAuto.checked THEN Aufmachen (NIL);
   EXCEPT
     ON Exception DO BEGIN
       Abhaengen (NIL);
       useOrder:= false; useFilter:= false;
     END;
   END;
 END;

procedure tSQLFormfo.setAscend (const sender: TObject);
 BEGIN
   WITH OrderEdit DO BEGIN
     Value:= Value+ ' asc, ';
     OrderEdit.setFocus;
   END;
 END;

procedure tSQLFormfo.setDescend (const sender: TObject);
 BEGIN
   WITH OrderEdit DO BEGIN
     Value:= Value+ ' desc, ';
     OrderEdit.setFocus;
   END;
 END;

procedure tSQLFormfo.setAdvance (const sender: TObject);
 BEGIN
   WITH OrderEdit DO BEGIN
     Value:= Value+ ', ';
     OrderEdit.setFocus;
   END;
 END;

procedure tSQLFormfo.ColOrder (const sender: TObject);
 BEGIN
   IF currCol <> '' THEN
     WITH OrderEdit DO BEGIN
       Value:= Value+ '"'+ currCol+ '"';
     OrderEdit.setFocus;
   END;
 END;

procedure tSQLFormfo.ShowFilter (const sender: TObject);
 BEGIN
   ShowView (NIL);
   FilterForm.show;
   FilterEdit.setFocus;
 END;

procedure tSQLFormfo.ClearFilter (const sender: TObject);
 BEGIN
   FilterEdit.Value:= '';
 END;

procedure tSQLFormfo.ActiveFilter (const sender: TObject);
 BEGIN
   WITH FilterActive DO BEGIN
     IF Sender  <> NIL THEN FilterOn:= NOT FilterOn;
     IF FilterOn
       THEN glyph:= stg_dbfilteron
       ELSE glyph:= stg_dbfilterclear;
   END;
 END;

procedure tSQLFormfo.FilterTable (const sender: TObject);
 BEGIN
   HideView (NIL);
   useFilter:= Sender = TObject (FilterApply);
   FilterForm.hide;

   TRY
     Abhaengen (NIL);
     IF OptionMenuAuto.checked THEN Aufmachen (NIL);
   EXCEPT
     ON Exception DO BEGIN
       Abhaengen (NIL);
       useOrder:= false; useFilter:= false;
     END;
   END;
 END;

procedure tSQLFormfo.ColFilter (const sender: TObject);
 BEGIN
   IF currCol <> '' THEN
     WITH FilterEdit DO BEGIN
       Value:= Value+ '"'+ currCol+ '" ';
       FilterEdit.setFocus;
     END;
 END;

procedure tSQLFormfo.setOperator (const sender: TObject; var avalue: msestring;
                                  var accept: Boolean);
 begin
   WITH FilterEdit DO BEGIN
     Value:= TrimRight (Value)+ ' '+ aValue+ ' ';
     FilterEdit.setFocus;
   END;
 end;

procedure tSQLFormfo.selectField (const sender: TObject; var avalue: msestring;
                                  var accept: Boolean);
 begin
   IF FilterForm.visible OR OrderForm.visible
     THEN currCol:= avalue;
 end;


procedure tSQLFormfo.Calculate (const sender: TObject);
 VAR
   DialogForm: tFloatCalcPadfo;
 begin
   DialogForm:= tFloatCalcPadfo.Create (Self, 'Calculator');
   DialogForm.Caption:= 'Calculator';

   WITH DialogForm {AS tFloatCalcPadfo} DO
     IF execute = mr_ok THEN copytoclipboard (GetText);  {set clipboard entry}

   FreeAndNil (DialogForm);
   IF FilterForm.visible THEN FilterEdit.setFocus
   ELSE IF OrderForm.visible THEN OrderEdit.setFocus
   ELSE SetFocus (true);
 end;

procedure tSQLFormfo.ShowDate (const sender: TObject);
 VAR
   DialogForm: tPopupCalendarFo;
   Kalender:   tCustomCalendarDatetimeEdit;
 begin
   Kalender:= tCustomCalendarDatetimeEdit.create (NIL);
   DialogForm:= tPopupCalendarFo.create (Self, Kalender.dropdown, 'Calendar');
   DialogForm.Caption:= 'Select a date';

   WITH DialogForm DO BEGIN
     Value:= LastDate;
     IF execute = mr_ok THEN BEGIN
       LastDate:= Value; copytoclipboard (DateTimeToStr (LastDate));  {set clipboard entry}
     END;
   END;
   Kalender.Free;
   FreeAndNil (DialogForm);
   IF FilterForm.visible THEN FilterEdit.setFocus
   ELSE IF OrderForm.visible THEN OrderEdit.setFocus
   ELSE SetFocus (true);
 end;

procedure tSQLFormfo.EditMemo (const sender: TObject);
 VAR
   DialogForm: tmseMemoDialogFo;
 begin
   DialogForm:= tmseMemoDialogFo.Create (Self, 'NoteMemo');

   WITH DialogForm AS tmseMemoDialogFo DO BEGIN
     Memo.Value:= concatStrings (MemoText, c_linefeed);
     IF execute = mr_ok THEN MemoText:= breakLines (Memo.Value);
   END;
   FreeAndNil (DialogForm); Activate; SetFocus (true);
 end;

procedure tSQLFormfo.changeFont (CONST FontBeingSet: tWidgetFont);
 begin
   WITH DBDaten, FontBeingSet DO BEGIN
     Frame.ColorClient:= ColorBackground;
     OrderEdit.Frame.ColorClient:= ColorBackground;
     FilterEdit.Frame.ColorClient:= ColorBackground;
     ColorBackground:= cl_default;
     Font:= FontBeingSet;
     OrderEdit.Font:= FontBeingSet;
     FilterEdit.Font:= FontBeingSet;
     ColorBackground:= Frame.ColorClient;
  END;
 end;

procedure tSQLFormfo.SetFont (const sender: TObject);
 VAR
   DialogForm: tFontDialogfo;
 BEGIN
   DialogForm:= tFontDialogfo.create (Self, 'FontDialog');
   DialogForm.Caption:= 'Set font and background color';

   WITH DialogForm DO BEGIN
     Font:= DBDaten.Font; Font.Style:= DBDaten.Font.Style;
     Font.ColorBackground:= DBDaten.Frame.ColorClient;
     // Needed here because style change after primary setting,
     Font:= Font;  // otherwise will not display style correctly!
     BgColor:= DBDaten.Frame.ColorClient; FontSetter:= @changeFont;
     fontsizeselector.enabled:= true;
     IF Execute = mr_ok THEN changeFont (Font);
   END;
   FreeAndNil (DialogForm); SetFocus (true);
 END;


PROCEDURE tSQLFormfo.SetFilename (CONST Sender: TObject);
 BEGIN
   WITH Self.Statfile DO BEGIN
     IF ParamCount > 0 THEN BEGIN   // Parameter 1 is stat file name, others are ignored
       FileName:= ExtractFilePath (Argv [1]);
       IF FileName <> '' THEN FileDir:= FileName;

       FileName:= ExtractFilename (Argv [1]);
       IF ExtractFileExt (Argv [1]) = '' THEN FileName:= FileName+ StatExt;  // standard extension
     END
     ELSE Options:= Options+ [sfo_useexename];
   END;
 END;

procedure tSQLFormfo.AssessStates (const sender: TObject; const filer: tstatfiler);
 VAR
   Entry:    string;
   MemFiles: msestringarty;
 begin
   IF filer IS tStatReader THEN BEGIN
     Dbasename.Value:= ''; Tablename.Value:= '';   // Clear on initial read

     MemFiles:= (filer AS tStatReader).ReadArray ('savedmemoryfiles', msestringarty (NIL));
     registerSavedMemoryFiles{Dialogs} (PStateFile, MemFiles);

     FOR Entry IN MemFiles DO
       IF System.Pos (DBSign, Entry) = 1 THEN  // for data tables only
         NewTablefcts (System.Copy (Entry, 1, Length (Entry)- Length (StatExt)){remove ".sta"});
   END;
//   IF filer IS tStatWriter THEN BEGIN END; -- not needed here!
 end;

procedure tSQLFormfo.ReadStates (const sender: TObject; const reader: tstatreader);
 VAR
   Host, User,
   Pass: string;
 begin
//   Dbasename.Value:= ''; Tablename.Value:= '';  -- done here already

   WITH Reader DO BEGIN
     WITH Dbasename DO Value:= ReadString  ('Database', Value);
     WITH Tablename DO Value:= ReadString  ('Table',    Value);

     WITH PostConnection DO BEGIN
       getPgAccess (Host, User, Pass);
       IF (Host = '') OR (User = '') OR (Pass = '') THEN BEGIN
         HostName:= ReadString  ('HostName', HostName);
         UserName:= ReadString  ('UserName', UserName);
         Password:= ReadString  ('Password', Password);
         Self.HostName.Text:= HostName;
         Self.UserName.Text:= UserName;
         Self.Password.Text:= Password;
         WITH OptionMenuPass DO
           state:= state- [as_disabled, as_localdisabled];
         WITH PopupMenuPass DO
           state:= state- [as_disabled, as_localdisabled];
       END
       ELSE BEGIN
         HostName:= Host; UserName:= User; Password:= Pass;
         WITH OptionMenuPass DO
           state:= state+ [as_disabled, as_localdisabled];
         WITH PopupMenuPass DO
           state:= state+ [as_disabled, as_localdisabled];
       END;
     END;

     OptionMenuAuto.checked:=  ReadBoolean ('AutoOpen', OptionMenuAuto.checked);
     getAutoopen (NIL);

     WITH DBDaten DO BEGIN
       Font.Name:=         ReadString  ('FontName', 'stf_default');
       Font.Height:=       ReadInteger ('FontSize');
       Font.Style:=
             fontstylesty (ReadInteger ('FontStyle'));
       Font.Color:=        ReadInteger ('FontColor');
       Frame.ColorClient:= ReadInteger ('FieldColor');
       Font.ColorSelect:=  ReadInteger ('SelectColor');
       Font.ColorSelectBackground:=
                           ReadInteger ('SelectBgnd');
       FilterEdit.Frame.ColorClient:= Frame.ColorClient;
       OrderEdit.Frame.ColorClient:=  Frame.ColorClient;
       FilterEdit.Font:= Font;
       OrderEdit.Font:=  Font;
     END (* WITH DBDaten *);

     TRY
       LastDate:= StrToDate (ReadString ('LastDate', ''));
     EXCEPT ON EConvertError DO
       LastDate:= Now;
     END;
   END;
 end;

procedure tSQLFormfo.ReadTablefcts (const sender: TObject; const reader: tstatreader);
 begin
   IF Tablename.Value <> '' THEN BEGIN
     WITH Reader DO BEGIN
       FilterOn:= ReadBoolean        ('filtered', false);
       FilterEdit.Value:= ReadString ('Filter',   '');
       OrderOn:= ReadBoolean         ('ordered',  false);
       OrderEdit.Value:= ReadString  ('Order',    '');
     END;
     ActiveFilter (NIL); ActiveOrder (NIL);
   END;
 end;

procedure tSQLFormfo.StateRead (const sender: TObject);
 begin
   IF OptionMenuAuto.checked THEN BEGIN
     useOrder:=  OrderOn  AND (OrderEdit.Value  <> '');
     useFilter:= FilterOn AND (FilterEdit.Value <> '');
   END;
 end;

procedure tSQLFormfo.WriteStates (const sender: TObject; const writer: tstatwriter);
 begin
   WITH Writer DO BEGIN
     IF (OptionMenuPass.state * [as_disabled, as_localdisabled]) = []
     THEN BEGIN
       WriteString  ('HostName', PostConnection.HostName);
       WriteString  ('UserName', PostConnection.UserName);
       WriteString  ('Password', PostConnection.Password);
     END;
     WriteString  ('Database', Dbasename.Value);
     WriteString  ('Table',    Tablename.Value);
     WriteBoolean ('AutoOpen', OptionMenuAuto.checked);

     WITH DBDaten DO BEGIN
       WriteString  ('FontName',    Font.Name);
       WriteInteger ('FontSize',    Font.Height);
       WriteInteger ('FontStyle',   integer (Font.Style));
       WriteInteger ('FontColor',   Font.Color);
       WriteInteger ('FieldColor',  Frame.ColorClient);
       WriteInteger ('SelectColor', Font.ColorSelect);
       WriteInteger ('SelectBgnd',  Font.ColorSelectBackground);
     END;

     WriteString  ('LastDate', FormatDateTime ('dd.mm.yyyy', LastDate));
   END;
 end;

procedure tSQLFormfo.WriteTablefcts (const sender: TObject; const writer: tstatwriter);
 begin
   IF Tablename.Value <> '' THEN
     WITH Writer DO BEGIN
       WriteBoolean ('filtered', FilterOn);
       WriteString  ('Filter',   FilterEdit.Value);
       WriteBoolean ('ordered',  OrderOn);
       WriteString  ('Order',    OrderEdit.Value);
     END;
 end;

// New table opened, check for & if neccessary create statfile
// CONST parameters cannot passed on further!?
FUNCTION tSQLFormfo.findFcts ({const} newTable: string): tstatfile;
  VAR
    i: integer;
 begin
   FOR Result IN TableFunctions DO
     IF uppercase (Result.Name) = uppercase (newTable)
       THEN Exit;

   Result:= NIL;   // nothing found...
 end;

procedure tSQLFormfo.NewTablefcts (const newTable: string);
 VAR
   NewStatfile: tstatfile;
 begin
    NewStatFile:= findFcts (newTable);

   IF NewStatFile = NIL THEN
     TRY
       NewStatfile:= tstatfile.create (Self);
  
       WITH NewStatfile DO BEGIN
         Name:= uppercase (newTable);
         filename:= uppercase (newTable+ StatExt);
         options:= options+ [sfo_memory, {sfo_createpath,} sfo_autoreadstat, sfo_autowritestat];
         StatFile:= PStateFile;
         onStatRead:= @ReadTablefcts; onStatWrite:= @WriteTablefcts;
         onStatAfterRead:= @StateRead;
       END;
       WITH PStateFile DO
         IF System.Pos (uppercase (newTable+ StatExt), savedmemoryfiles) = 0 THEN
          IF savedmemoryfiles <> ''
            THEN savedmemoryfiles:= NewStatfile.filename+ ' '+ savedmemoryfiles
            ELSE savedmemoryfiles:= NewStatfile.filename;

       SetLength (TableFunctions, succ (Length (TableFunctions)));
       TableFunctions [high (TableFunctions)]:= NewStatFile;
     EXCEPT
       ON Exception DO FreeAndNil (NewStatfile);  // didn't work...
   END;
   IF NewStatfile <> NIL
     THEN NewStatFile.ReadStat;
 end;

procedure tSQLFormfo.saveTableFcts (const newTable: string);
 VAR
   NewStatfile: tstatfile;
 begin
   NewStatfile:= findFcts (newTable);
   IF NewStatfile <> NIL
     THEN NewStatfile.WriteStat;
 end;


// Communication between main and popup menus
procedure tSQLFormfo.getAutoopen (const sender: TObject);
 BEGIN
   PopupMenuAuto.checked:= OptionMenuAuto.checked;
 END;

procedure tSQLFormfo.setAutoopen (const sender: TObject);
 BEGIN
   OptionMenuAuto.checked:= PopupMenuAuto.checked;
 END;

procedure tSQLFormfo.getLogin (const sender: TObject);
 begin
   Abhaengen (Self);
   WITH PostConnection DO
     IF NOT Connected THEN BEGIN
       Self.UserName.Text:= UserName;
       UserDataForm.show;
     END;
 end;

procedure tSQLFormfo.TryLogin (const sender: TObject);
 VAR
   oldUser, oldPass: string;
 begin
   WITH PostConnection DO BEGIN
     oldUser:= UserName; oldPass:= Password;
     UserName:= Self.UserName.Text;
     Password:= Self.Password.Text;
     TRY
     Connected:= (UserName <> '') AND (Password <> '');
     EXCEPT
       ON Exception DO Connected:= false;
     END;
     IF NOT Connected THEN BEGIN
       UserName:= oldUser; Password:= oldPass;
       Self.UserName.Text:= 'FAILED!';
     END;
     IF Connected THEN BEGIN
       Connected:= false;
       UserDataForm.hide;
     END;
   END;
 end;

procedure tSQLFormfo.Fieldsize (const FieldDef: TFieldDef; out Length, Decs: integer);
 begin
   WITH FieldDef DO
     CASE DataType OF
       ftBoolean:
         BEGIN
           Length:= -1; Decs:= 1;
         END;
       ftSmallint:
         BEGIN
           Length:= -1; Decs:= 2;
         END;
       ftinteger,
//       ftFloat,    // that's undecided ...
       ftDate:
         BEGIN
           Length:= -1; Decs:= 4;
         END;
       ftLargeint,
       ftFloat,    // ... rather use the larger?
       ftTime,
       ftDateTime:
         BEGIN
           Length:= -1; Decs:= 8;
         END;
       ftGuid:
         BEGIN
           Length:= -1; Decs:= 32;
         END;
       ELSE { pass'em thru }
         BEGIN
           Length:= Precision; Decs:= Size;
       END;
     END;
 end;


procedure tSQLFormfo.ErrorOnPost (DataSet: TDataSet; E: EDatabaseError;
                                  var DataAction: TDataAction);
 begin
   Write ('Error: ', E.Message, ' - ');
   CASE DataAction OF
     daFail:  WriteLn ('failed');
     daAbort: WriteLn ('aborted');
     daRetry: WriteLn ('retry');
   END;
   DataAction:= daFail;
 end;

procedure tSQLFormfo.ErrorOnUpdate (const sender: tmsebufdataset;
                                    var e: EDatabaseError; const updatekind: TUpdateKind;
                                    var response: resolverresponsesty);
 var answer: resolverresponsety;
 begin
   Write ('Error: ', E.Message, ' - ');
   CASE updatekind OF
     ukModify: Write ('modify:');
     ukInsert: Write ('insert:');
     ukDelete: Write ('delete:');
   END;
   FOR answer IN resolverresponsesty DO
   CASE answer OF
     rr_abort:   Write (' aborted');
     rr_quiet:   Write (' quiet');
     rr_revert:  Write (' revert');
     rr_again:   Write (' again');
     rr_applied: Write (' applied');
     rr_skipped: Write (' skipped');
   END;
   WriteLn;
end;

end.
