PROGRAM getPgAccess;

USES
  SysUtils, StrUtils;

CONST
  PgPass = '/.pgpass';


PROCEDURE getPgAccess (VAR Username, Password: string);
 VAR
   done:   boolean = false;
   PgName,
   PgLine: string;
   PgUser: TextFile;
 BEGIN
   PgName:= // used for pg user password file path
{$ifdef Windows}
              msestring (toSysfilePath (sys_getuserhomedir))+
{$else}
              GetEnvironmentVariable ('HOME')+
{$endif}
              PgPass;

   IF FileExists (PgName) THEN BEGIN
     Assign{File} (PgUser, PgName); Reset (PgUser);
     WHILE NOT (done OR EoF (PgUser)) DO BEGIN
       ReadLn (PgUser, PgLine);         // used for parsing
       IF (PgLine [1] <> '#') AND       // NOT a comment line
          (Pos ('*', PgLine) <> 0)      // general access
       THEN BEGIN
         Username:= ExtractWord (4, PgLine, [':']);
         Password:= ExtractWord (5, PgLine, [':']);
         done:= true;
       END;
     END;
     Close{File} (PgUser);
   END;
   IF NOT done THEN BEGIN
     Username:= ''; Password:= '';
   END;
 END;

VAR
  Username, Password: string;

BEGIN
  Username:= 'FAILED'; Password:= 'FAILED';
  getPgAccess (Username, Password);
  WriteLn ('Found Username: ', Username, ' and Password: ', Password);
END.
